<%@ page language="java" contentType="text/html; charset=UTF-8" %>
<%@ page import="com.medias.xml.hierarchie.Hierarchie" contentType="text/html; charset=UTF-8" %>
<%@ page import="com.medias.Context" %>
<%@ page import="com.ether.user.UserRole" %>
<%@ taglib uri="/WEB-INF/tlds/struts-tiles.tld" prefix="tiles" %>
<%@ taglib uri="/WEB-INF/tlds/struts-html.tld" prefix="html" %>
<%@ taglib uri="/WEB-INF/tlds/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/tlds/struts-logic.tld" prefix="logic" %>
<%@ taglib uri="/WEB-INF/tlds/struts-nested.tld" prefix="nested" %>

<tiles:insert page="/resources/templates/templateMegapoli.jsp" flush="true">

    <tiles:put name="insertCss" type="string"></tiles:put>
    <tiles:put name="insertJsOrJsp" type="string"></tiles:put>


    <tiles:put name="title" type="string"><bean:message key="app.title"/> - <bean:message key="data.upload"/></tiles:put>
    <tiles:put name="nav" type="string">
        <html:link page="/index.jsp"><bean:message key="app.home"/></html:link>&nbsp;&gt;
        <html:link page="/data?methodName=viewDataResume"><bean:message key="app.data"/></html:link>&nbsp;&gt;
        <html:link page="/PrepareTree.do"><bean:message key="data.upload"/></html:link>
    </tiles:put>

    <%--****************** CONTENT ****************** --%>
    <tiles:put name="bodytitle" type="string"><bean:message key="data.upload.title"/></tiles:put>

    <tiles:put name="body" type="string">
        <bean:message key="data.upload.accueil"/><br/>
        <bean:message key="data.upload.howto" arg0="<%=Context.getWebmaster(request)%>"/><br/>

        <logic:present name="<%=org.apache.struts.Globals.ERROR_KEY%>">
            <div id="errors"><html:errors/></div>
        </logic:present>

        <div id="messages">
            <html:messages id="mess" property="<%= org.apache.struts.action.ActionMessages.GLOBAL_MESSAGE %>" message="true">
                <bean:write name="mess"/>
            </html:messages>
        </div>

        <nested:root name="prepareTreeForm">
            <nested:nest property="hierarchie">

                <nested:iterate property="categories" indexId="categorieId">
                    <div id="level1">
                        <div class="title2">
                            <html:img page="/resources/images/utils/folder.png" alt="folder"/>
                            <bean:define id="numCateg" value='<%=""+(((Integer)categorieId).intValue()+1)%>'/>
                            <bean:message key="data.categ${numCateg}"/>
                        </div>

                        <nested:iterate property="jeux" indexId="jeuId">

                            <nested:define id="cheminJeu" property="chemin"/>
                            <nested:define id="fichierMetadonnee" property="fichierMeta"/>

                            <div id="level2" class="level2 level2_more">
                                <html:form action="/ConfirmDeletion">
                                    <html:img page="/resources/images/utils/folder.png" alt="folder"/>&nbsp;<nested:write property="nomJeu"/>
                                    <logic:equal name="SES_USER" property="roles" scope="session" value="<%=UserRole.COORDINATOR.name()%>">&nbsp;
                                        <html:hidden value="${cheminJeu}" property="path"/>
                                        <%--<html:image page="/resources/images/utils/delete.png" alt="delete" titleKey="data.upload.metadata.deleteJeu"/>--%>
                                        <input type="image" src="resources/images/utils/trash.png" width="20px" height="18px" alt="delete" title="<bean:message key='data.upload.metadata.deleteJeu'/>"/></input>
                                    </logic:equal>
                                </html:form>

                                <div id="level2">
                                    <bean:define id="path"
                                                 value='<%="" + ((Hierarchie)(application.getAttribute ("APP_UPLOADTREE"))).getDataRoot () + "/" + (String)cheminJeu + "/" + (String)fichierMetadonnee%>'/>
                                    <html:link page="/LoadMetadata.do" paramName="path" paramId="metadataUri"
                                               titleKey="data.upload.metadata.link">
                                        <html:img page="/resources/images/utils/metadata.png" alt="metadata"/>&nbsp;
                                        <bean:message key="data.upload.metadata"/>
                                    </html:link>
                                    <nested:equal property="metaComplet" value="false">
                                        <span style="color: red">(<bean:message key="data.upload.metadata.inc"/>)</span>
                                    </nested:equal>
                                    <nested:equal property="metaComplet" value="true">
                                        <span style="color: green">(<bean:message
                                                key="data.upload.metadata.comp"/>)</span>
                                    </nested:equal>
                                </div>

                                <div id="level2">

                                    <bean:define id="nbFiles"
                                                 value='<%="" + ((Hierarchie)(application.getAttribute ("APP_UPLOADTREE"))).getNbFiles ((String)cheminJeu)%>'/>
                                    <bean:define id="dateD"
                                                 value='<%="" + ((Hierarchie)(application.getAttribute ("APP_UPLOADTREE"))).getMinFileCreation ((String)cheminJeu)%>'/>
                                    <bean:define id="dateF"
                                                 value='<%="" + ((Hierarchie)(application.getAttribute ("APP_UPLOADTREE"))).getMaxFileCreation ((String)cheminJeu)%>'/>

                                    <logic:greaterThan name="nbFiles" value="0">
                                        <html:link page="/PrepareFileList.do" titleKey="data.upload.listFiles"
                                                   paramId="setPath" paramName="cheminJeu">
                                            <html:img page="/resources/images/utils/text.png"
                                                      altKey="data.upload.listFiles"/>
                                            &nbsp;
                                            <logic:equal name="nbFiles" value="1">
                                                <bean:message arg0="<%=nbFiles%>" key="data.upload.nbFiles.one"/>&nbsp;
                                            </logic:equal>
                                            <logic:notEqual name="nbFiles" value="1">
                                                <bean:message arg0="<%=nbFiles%>" key="data.upload.nbFiles"/>&nbsp;
                                            </logic:notEqual>
                                            <logic:equal name="dateD" value="<%=dateF%>">
                                                <bean:message arg0="<%=dateD%>" key="data.upload.sameDate"/>
                                            </logic:equal>
                                            <logic:notEqual name="dateD" value="<%=dateF%>">
                                                <bean:message arg0="<%=dateD%>" arg1="<%=dateF%>"
                                                              key="data.upload.differentDate"/>
                                            </logic:notEqual>
                                        </html:link>
                                    </logic:greaterThan>
                                    <logic:equal name="nbFiles" value="0">
                                        <bean:message key="data.upload.files.zero"/>
                                    </logic:equal>

                                </div>

                                <html:form action="/Upload" method="POST" enctype="multipart/form-data">
                                    <bean:define id="modify" value="false"/>
                                    <logic:iterate id="jeu" name="SES_USER" property="jeux" scope="session">
                                        <nested:define id="nomJ" property="nomJeu"/>
                                        <logic:equal name="jeu" value="${nomJ}">
                                            <bean:define id="modify" value="true"/>
                                        </logic:equal>
                                    </logic:iterate>
                                    <logic:equal name="SES_USER" property="roles" scope="session" value="<%=UserRole.COORDINATOR.name()%>">
                                        <bean:define id="modify" value="true"/>
                                    </logic:equal>
                                    <logic:equal name="modify" value="true">
                                        <div id="level2">
                                            <html:img page="/resources/images/utils/uploadText.png" alt="upload"/>&nbsp;
                                            <html:file property="newFile"/> &nbsp;
                                            <html:hidden property="path"
                                                         value="${cheminJeu}"/><html:submit><bean:message
                                                key="app.deposer"/></html:submit>
                                        </div>
                                    </logic:equal>
                                </html:form>
                            </div>
                        </nested:iterate>

                        <logic:equal name="SES_USER" property="roles" scope="session" value="<%=UserRole.COORDINATOR.name()%>">

                            <nested:define id="parent" property="nomCategorie"/>
                            <div id="level2">
                                <html:link page="/InitNewSet.do" titleKey="data.upload.newSet" paramId="categorie"
                                           paramName="parent">
                                    <html:img page="/resources/images/utils/newFolder.png"
                                              alt="new set"/>&nbsp;<bean:message key="data.upload.newSet"/>
                                </html:link>
                            </div>
                        </logic:equal>

                    </div>
                </nested:iterate>
            </nested:nest>
        </nested:root>

        <div class="hdp" align="right">
            <html:link href="#top" titleKey="app.hdp">
                <html:img page="/resources/images/utils/fleche_haut.gif" width="20px" height="20px"/>
            </html:link>
        </div>
    </tiles:put>

</tiles:insert>